clear all;  close all;
addpath '../';
addpath '../../utilities';
n = 10000;
logw = (1e-6)*norminv(linspace(0.5/n, 1-0.5/n, n))';
ress = 0.5;
bound = inf;

disp('New code')
crit = 1e-16;
tic
rpower = l_annealpower(logw, ress, bound, crit, false);
toc
fprintf('rpower = %12.6e\n', rpower)
w = exp(logw - max(logw));
% fprintf('Check = %12.6e\n', 2*l_logsumlog(rpower*logw) ...
%   - l_logsumlog(2*rpower*logw) - log(length(logw)*ress))

fprintf('Check = %12.6e\n', 2*u_logsumlog(rpower*logw, 1, false) ...
    - u_logsumlog(2*rpower*logw, 1, false) - log(length(logw)*ress))

crit = 1e-6;
disp('Old code')
tic
rpower = l_annealpower_old(logw, ress, bound, crit);
toc
fprintf('rpower = %12.6e\n', rpower)
w = exp(logw - max(logw));
fprintf('Check = %20.15f\n', ...
    (sum(w.^rpower))^2 - ress*length(w)*sum(w.^(2*rpower)))

matlabpool(2)
logw1(:,1) = logw(1:n/2);
logw1(:,2) = logw(n/2 +1:n);
spmd
    logw2 = logw1(:,labindex);
    rpower1 = l_annealpower(logw2, ress, bound, crit, true);
    fprintf('rpower = %12.6e\n', rpower1)
    if labindex == 1
        rpower2 = rpower1(labindex);
    end
end
matlabpool close;






