clear all; close all;
addpath ../
global E
E.gpu = false;
nvalues = [0, 0, 1, 5, 20, 100, 500, 1000];
nrep = 100000;
a = exp(randn(nrep, 1));
for s = 1:length(nvalues);
    n = nvalues(s);
    tic
    y1 = gammaln(a+n) - gammaln(a);
    time1 = toc;
    tic
    y2 = l_gammaratio(a, n);
    time2 = toc;
    diff = sum(abs(y1-y2) > 1e-10)/nrep;
    fprintf('%8.4f %8.4f %8.4f\n', time1, time2, diff)
end
    
