clear all;  close all;

fprintf('\nBeing used: %s\n', mfilename('fullpath'));
u_setmodelproj('MVN', 'toyMVN_example');

global E
E.gpu   = false;

nsim = 100000;
intensity = 1;
muS = [0 0 0];
n = length(muS);
SigS = diag(chi2rnd(4, n, 1)/4);
CholInvSigS = chol(eye(n)/SigS);
CholInvSigS = reshape(CholInvSigS, 1, n^2);

H_diag_pointer = cumsum(1:n);
tot_pointer = 1:(1/2*(n^2) + 1/2*n);
tot_pointer(H_diag_pointer) = [];
H_offdiag_pointer = tot_pointer;

B_counter = 4;
H_diag_pointer = B_counter + H_diag_pointer;
H_offdiag_pointer = B_counter + H_offdiag_pointer;

mdiag_pointer = zeros(1, n);
moffdiag_pointer = zeros(1, length(H_offdiag_pointer));
for i = 1:n
    mdiag_pointer(1, i) = 1 + (i - 1)*(n + 1);
end
counter = 0;
for i = 2:n
    moffdiag_pointer((counter + 1):(counter + i- 1))...
        = ((i - 1)*n + 1):((i - 1)*n + i - 1);
    counter = counter + i - 1;
end

fprintf('Check:    Mean \n')
disp(muS)
fprintf('Check:    Variance \n')
disp(SigS)

y = mvnrnd(repmat(muS, nsim, 1), SigS);
y_pointer = 1:n;
x_pointer = [];

Amap = [];
Bmap = [];
irow = [1 1 2 1 2 3]';
icol = [1 2 2 3 3 3]';
Hmap = [irow icol];

H = zeros(1, B_counter + n);
H(1, H_diag_pointer) = log(CholInvSigS(1, mdiag_pointer));
H(1, H_offdiag_pointer) = CholInvSigS(1, moffdiag_pointer);
theta = H;
H_pointer = 1:size(theta, 2);
A_tri = true;

py = zeros(nsim, 1);
for isim = 1:nsim
    data = y(isim, :);
    logpy = l_mvnormal(theta, data, x_pointer, y_pointer, Amap, Bmap, ...
        Hmap, A_tri, intensity);
    py(isim) = exp(logpy);
end

[tstatout, pstatout] = u_pdfcheck(y, py, 1);

