clear all;  close all;
addpath ../
global E
E.gpu = false;
T = 6;
JN = 2;
data = [[ones(T, 1), 0.2*randn(T, 2)], poissrnd(5, T, 1)];
xindex = [1, 2];
zindex = [1, 3];
yindex = 4;
theta = [0.1, 0.1, -2, 0.1; -0.1, -0.1, -3, 0];
alphaindex = [1, 2];
betaindex = [3, 4];
% intensity = ones(T,1);
intensity = rand(T,1);
intensity(4) = 0;

logpdf = l_negbin(theta, alphaindex, betaindex, ...
    intensity, data, zindex, xindex, yindex, 1);
disp('Brute force');  disp(logpdf')

logpdf = l_negbin(theta, alphaindex, betaindex, ...
    intensity, data, zindex, xindex, yindex, 2);
disp('C/CUDA');  disp(logpdf')

logpdf = l_negbin(theta, alphaindex, betaindex, ...
    intensity, data, zindex, xindex, yindex, 3);
disp('Matlab');  disp(logpdf')

data1 = data(1,:);
p = zeros(size(theta,1),10);
intensity = 1;
for i = 1:10
    data1(1,4) = i-1;
    p(:,i) = exp(l_negbin(theta, alphaindex, betaindex, ...
        intensity, data1, zindex, xindex, yindex, 3));
end
disp([100*p,100*sum(p,2)])