clear all;  close all;
addpath ../
global E
E.gpu = false;
T = 6;
JN = 2;
data = [[ones(T, 1), randn(T, 1)], poissrnd(5, T, 1)];
xindex = [1, 2];
yindex = 3;
theta = 0.1*[5 -0.2; 4 1];
intensity = rand(T,1);
intensity(4) = 0;

logpdf = l_poisson(theta, intensity, data, xindex, yindex, 1);
disp('Brute force');  disp(logpdf')

logpdf = l_poisson(theta, intensity, data, xindex, yindex, 2);
disp('C/CUDA');  disp(logpdf')

logpdf = l_poisson(theta, intensity, data, xindex, yindex, 3);
disp('Matlab');  disp(logpdf')

data1 = data(1,:);
p = zeros(size(theta,1),10);
intensity = 1;
for i = 1:10
    data1(1,3) = i-1;
    p(:,i) = ...
        exp(l_poisson(theta, intensity, data1, xindex, yindex, 2));
end
disp([100*p,100*sum(p,2)])