function m_monitor(stage)

global C E M

p_monitor(stage)

if strcmp(stage, 'startrun') && ~C.simget
    M = u_tidyfields(M);
    
    %  Data (general)
    [~, k] = u_datacheck;
    
    %  Model (general)
    u_isfield(M, 'specification', true, 'M');
    fprintf('\n SABL MVN model %s, %s specification\n', ...
                M.specification)
    M.oldintensity = 0;
    
    %  Specific to model specification
    
    if strcmp(M.specification, 'FI')
        %  Data
        u_isfield(C, 'parameters', true, 'C');
        u_pointercheck(M, 'M', k, 'x_pointer', k-1, 'y_pointer', k-1)
        M.n = length(M.y_pointer);
        M.k = length(M.x_pointer);
        if ~strcmp(C.Cphase_method, 'data_whole')
            M.F = u_factor(M.data(:, [M.y_pointer', M.x_pointer']));
            M.T = size(M.data, 1);
        end
        M.oldintensity = 0;
        %  Parameters
        M = u_blankfields(M, 'Alinc', 'Blinc', 'Hlinc');
        [M, M.Amaptype] = u_mapcheck(M, 'M', 'Amap', [M.n, M.n], ...
            C.parameters, 'Alinc');
        M.A_tri = all(all(M.Amap == triu(M.Amap))) || ...
        all(all(M.Amap == tril(M.Amap)));
        [M, M.Bmaptype] = u_mapcheck(M, 'M', 'Bmap', [M.n, M.k], ...
            C.parameters, 'Blinc');
        [M, M.Hmaptype] = u_mapcheck(M, 'M', 'Hmap', [M.n, M.n], ...
            C.parameters, 'Hlinc');
        if ~all(all(triu(M.Hmap)==M.Hmap))
            error('M.Hmap must be upper triangular')
        end
        M.easymap = ...
            ~(E.gpu && (M.Amaptype(4) || M.Bmaptype(4) || M.Hmaptype(4)));
        %  Prior
        u_isfield(M, 'prior', true, 'M');
        
    elseif strcmp(M.specification, 'SUR')
        
    elseif strcmp(M.specification, 'LI')
        
    elseif strcmp(M.specification, 'SSI')
        
    elseif strcmp(M.specification, 'MVR')
        
    elseif strcmp(M.specification, 'VAR')
        
    elseif strcmp(M.specification, 'custom')
        
    else
        error('M.specification = %s unrecognized', M.specification)
    end
    
end

end
