clear all;  close all;
global C E M
A = [0 0.5; 0 0];
B = [0.5 1 0; -0.7 0 0.5];
H = [1.2 0.3; 0 0.8];
M.Amap = [0 1; 0 0];
M.Bmap = [2 3 0; 4 0 5];
M.Hmap = [6 7; 0 8];
M.easymap = true;
X = [1, randn(1, 2)];

M.T = 1;
M.Alinc = [];
M.Blinc = [];
M.Hlinc = [];
M.A_tri = true;
E.gpu = false;
C.Cphase_method = 'anneal_Bayes';
nsim = 1e4;

[n, k] = size(B);
npars = max([max(max(M.Amap)), max(max(M.Bmap)), max(max(M.Hmap))]);
theta1 = zeros(1, npars);
for i = 1:n
    for j = 1:n
        if M.Amap(i,j)>0
            theta1(M.Amap(i,j)) = A(i,j);
        end
    end
end
for i = 1:n
    for j = 1:k
        if M.Bmap(i,j)>0
            theta1(M.Bmap(i,j)) = B(i,j);
        end
    end
end

for i = 1:n
    if M.Hmap(i,i)>0
        theta1(M.Hmap(i,i)) = log(H(i,i));
    end
    for j = i+1:n
        if M.Hmap(i,j)>0
            theta1(M.Hmap(i,j)) = H(i,j);
        end
    end
end

ysim = zeros(nsim, n);
pdf = zeros(nsim, 1);
for isim = 1:nsim
    ysim(isim,:) = m_mvnsim(X, 1, A, B, H);
    M.F = u_factor([ysim(isim,:), X]);
    pdf(isim) = exp(m_message(theta1, 1));
end

u_pdfcheck(ysim, pdf, true);