clear all;  close all;
addpath('../');
intensity = ones(100,1);
n = 24000;
K = 2;
I = 3;
muY = 0.001;
sigY = 0.9;
alpha = [.4, .65];
beta = [1.3, 0.2];
gamma = [0.5, 0.2];
p = [0.2235, 0.4488, 0.3277];
mu = [-0.4185 0.4591 -0.3434];
sig = [1.0837 0.6577 1.0640];
K = length(alpha);
I = length(mu);
y = m_egarch1sim(muY, sigY, alpha', beta', gamma', p', mu', sig', ...
    1, length(intensity), 1)';

tic;
muY = repmat(muY,n,1);
sigY = repmat(sigY,n,1);
alpha = repmat(alpha,n,1);
beta = repmat(beta,n,1);
gamma = repmat(gamma,n,1);
p = repmat(p,n,1);
mu = repmat(mu,n,1);
sig = repmat(sig,n,1);
tic;
logpycpu = m_egarch2(muY,sigY,alpha,beta,gamma,p,mu,sig,...
    y, intensity, zeros(n,K), zeros(n,1));
timecpu = toc;

fprintf('CPU time:%8.3f\n',timecpu)

npools = 12;
seglength = n/npools;
nend = seglength:seglength:n;
nstart = nend - seglength + 1;

tic;
logpymc = zeros(seglength,npools);
muY = reshape(muY,seglength,npools);
sigY = reshape(sigY,seglength,npools);
alpha = reshape(alpha,seglength,npools,K);
beta = reshape(beta,seglength,npools,K);
gamma = reshape(gamma,seglength,npools,K);
p = reshape(p,seglength,npools,I);
mu = reshape(mu,seglength,npools,I);
sig = reshape(sig,seglength,npools,I);
% matlabpool(npools);

parfor j = 1:npools
    nn = nstart(j):nend(j);
    logpymc(:,j) = m_egarch2(muY(:,j),sigY(:,j),...
        squeeze(alpha(:,j,:)),squeeze(beta(:,j,:)),squeeze(gamma(:,j,:)),...
        squeeze(p(:,j,:)),squeeze(mu(:,j,:)),squeeze(sig(:,j,:)),y,intensity,...
        zeros(seglength,K),zeros(seglength,1));    
end

timemc = toc;
fprintf('Multicore time:%8.3f\n',timemc);