#define SQRT2PI           2.506628274631000  // sqrt(2*pi)
#define SQRT2             1.414213562373095   // sqrt(2)
#define LOG_SQRT2PI       0.918938533204673   // log( sqrt(2*pi) )


template <typename T>
__device__
T normal_cdf( T z ) {
//    return 0.5f * ( 1.0f + erf( z/SQRT2 ));
    return normcdf( z );   // Now a cuda intrinsic
}

template <typename T>
__device__
T normal_cdf( T x, T mu, T sd ) {
    T z = (x-mu)/sd;
//    return 0.5f * ( 1.0f + erf( z/SQRT2 ));
    return normcdf( z );   // Now a cuda intrinsic
}

template <typename T>
__device__ 
T normal_pdf( T z ) {
    return exp( -0.5f*z*z ) / SQRT2PI;
}


template <typename T>
__device__ 
T normal_pdf( T x, T mu, T sd )
{
    T z = (x-mu)/sd;
    return exp( -0.5f*z*z ) / ( sd * SQRT2PI );
}


template <typename T>
__device__ 
T log_normal_pdf( T z )
{
    return -0.5f*z*z  - LOG_SQRT2PI;
}


template <typename T>
__device__ 
T log_normal_pdf( T x, T mu, T sd )
{
    T z = (x-mu)/sd;
    return -0.5f*z*z  - log( sd * SQRT2PI );
}

