clear all;  close all;
addpath('../');
addpath('../../../utilities');
nsim = 10000;
intensity = ones(3,1);
K = 2;
I = 3;
muY = 0.001;
sigY = 0.9;
alpha = [.4, .65]';
beta = [1.3, 0.2]';
gamma = [0.5, 0.2]';
p = [0.2235, 0.4488, 0.3277]';
mu = [-0.4185 0.4591 -0.3434]';
sig = [1.0837 0.6577 1.0640]';
fprintf('Check: %9.4f %9.4f\n',dot(p,mu),dot(p,(mu.^2+sig.^2)))

y = m_egarch1sim(muY, sigY, alpha, beta, gamma, p, mu, sig, 1, ...
    length(intensity), nsim);
py = zeros(nsim,1);
for isim = 1:nsim
    logpy = m_egarch1(muY, sigY, alpha, beta, gamma, p, mu, sig, ...
        y(isim,:)', intensity, zeros(K,1), 0);
    py(isim) = exp(logpy);
end

[tstatout,pstatout] = u_pdfcheck(y,py,1);