clear all;  close all;
addpath('../');
intensity = ones(3,1);
n = 3;
K = 2;
I = 3;
muY = 0.001;
sigY = 0.9;
alpha = [.4, .65]';
beta = [1.3, 0.2]';
gamma = [0.5, 0.2]';
p = [0.2235, 0.4488, 0.3277]';
mu = [-0.4185 0.4591 -0.3434]';
sig = [1.0837 0.6577 1.0640]';
fprintf('Check: %9.4f %9.4f\n',dot(p,mu),dot(p,(mu.^2+sig.^2)))

y = m_egarch1sim(muY, sigY, alpha, beta, gamma, p, mu, sig, ...
    1, length(intensity), 1);
logpy1 = m_egarch1(muY, sigY, alpha, beta, gamma, p, mu, sig, ...
        y', intensity, zeros(K,1), 0);
logpy2 = m_egarch2(repmat(muY,n,1), repmat(sigY,n,1), ...
    repmat(alpha',n,1), repmat(beta',n,1), repmat(gamma',n,1),...
    repmat(p',n,1), repmat(mu',n,1), repmat(sig',n,1),...
    y', intensity, zeros(n,K), zeros(n,1));
disp(std(logpy2))
disp([logpy1, logpy2(1), logpy1-logpy2(1)])
    