clear all;  close all;
global E M

addpath '../'

E.gpu = false;
M.data = [1 0.2 -0.3 1.2  3;
          1 -0.5  0.8 -0.6 4];
JN = 1e7;
ntest = 1;

if ntest == 1
    M.x_pointer = [1, 2]';
    M.z_pointer = [1, 3]';
    M.y_pointer = 5;
    theta = [0.4, 0.5, 0.6, 0.2];
    M.betmap = (1:2)';
    M.gammap = (3:4)';
    M.easymap = true;
    tsim = [1; 2];
end

logp1 = zeros(6);
intensity = ones(2, 1);
for i = 1:6
    for j = 1:6
        M.data(1,M.y_pointer) = i-1;
        M.data(2,M.y_pointer) = j-1;
        logp1(i,j) = m_message(theta, intensity);
    end
end 
theta = repmat(theta, JN, 1);
ysim = m_negative_binomialsim(M.data, tsim, M.x_pointer, M.z_pointer, ...
    theta, M.betmap, M.gammap);
p1 = exp(logp1);
p2 = zeros(6);
for jn = 1:JN
    i = ysim(1,jn)+1;
    j = ysim(2,jn)+1;
    
    if i <=6 && j <= 6
        p2(i,j) = p2(i,j) + 1;
    end
end
p2 = p2/JN;
disp('m_negtive_binomial probabities')
disp(p1)
disp('m_negative_binomial frequencies')
disp(p2)
disp('Test statistics')
disp((p2-p1)./sqrt((p1.*(1-p1))/JN))