function g = m_rnefunctions(theta)
%  This function specifies the evalaution functions for the RNE stopping
%  rule in the M phase.
%
%  Input:
%  theta     Parameter vectors (C.JNwork x C.parameters)
%
%  Output:
%  g         Functions of theta used for RNE computation (C.JNwork x ng)

global M

if M.rnecustom
    g = p_rne(theta);
    return
end

bet = u_collectpart(theta, M.betmap, M.betlinc, 'bet');
gam = u_collectpart(theta, M.gammap, M.betlinc, 'gam');

g = [bet*M.xmean, gam*M.zmean];

end