clear ;  close all;
addpath '../'

JN  = 1e5;
intensity = 1;
XX = [1 2; 3 4];
tsim = 1;

betmap  = [1 2];
betlinc = [];
gammap  = [3 4];
gamlinc = [];

y_pointer = 3;
x_pointer = [1 2];
z_pointer = [1 2];
% theta = ones(JN, 2);
theta = repmat([1, 0.7, 0.5, 0.8], JN, 1);

y  = m_normalsim(XX, tsim, x_pointer, z_pointer, theta, ...
    betmap, gammap)';

bet = u_collectpart(theta, betmap, betlinc, 'bet');
gam = u_collectpart(theta, gammap, gamlinc, 'gam');

py = zeros(JN,1);
for isim = 1:JN
    data = [XX(tsim, :) y(isim)];
    logpy = l_normal(bet(isim, :), gam(isim, :), data, x_pointer, ...
        z_pointer, y_pointer, intensity);
    py(isim) = exp(logpy);
end

[tstatout,pstatout] = u_pdfcheck(y,py,1);