function logp = m_message(theta, intensity)
%  This function sets up the evaluation of the log-likelihood by the
%  function l_poisson or l_poisson_CUDA
%
%  Inputs:
%  theta      Matrix of particles (C.JNwork x C.parameters)
%  intensity  Vector of current information intensity (C.tlast x 1)
%
%  Output:
%  logp       Current information about theta

global E M

if M.easymap  % Designates bet = theta so no reason to use memory for bet
    if E.gpu 
        logp = l_poisson_CUDA(theta(:,M.betamap), M.data, ...
            M.x_pointer, M.y_pointer, intensity);
    else
        logp = l_poisson(theta(:,M.betamap), M.data, ...
            M.x_pointer, M.y_pointer, intensity);
    end

else 
    bet = u_collectpart(theta, M.betamap, M.betalinc, 'beta');
    if E.gpu 
        logp = l_poisson_CUDA(bet, M.data, M.x_pointer, M.y_pointer, ...
            intensity);
    else
        logp = l_poisson(bet, M.data, M.x_pointer, M.y_pointer, intensity);
    end
    
end