function p_monitor(stage)

global C M Cpar E

if strcmp(stage, 'open')
    % E.gpu = true;
    % E.pus = 2;
    
elseif strcmp(stage, 'startrun')
    %    fprintf('\n%s\n', mfilename('fullpath')); % restore to check if correct p_monitor.m being invoked, useful when having multiple p_monitor.m % Huaxin, 24 June
    M.specification = 'FI';
    ntest = 1;
 
    if ntest == 1
        %  Part 1: Set up the data
        
        %  Part 2: Make any changes to SABL default parameters
        n = 2;
        k = 3;
        A = [0, .5; 0, 0];
        B = 3*randn(n, k);  B(1,2) = 0;
        sigma = eye(n);
        T = 2000;
        [X, Y] = datagen(A, B, sigma, T);
        M.data = [X, Y];
        M.x_pointer = (1:3)';
        M.y_pointer = (4:5)'; 
        H = chol(sigma);
        %  Part 3: Set up the specification and parameters
        C.parameters = 9;
        M.Amap = [0, 1; 0, 0];
        M.Bmap = [2 3; 0 4; 5 6]';
        M.Hmap = [7 8; 0 9];
    
        %  Part 4: Set up the prior
        M.prior{1}.distribution = 'normal';
        M.prior{1}.mean = zeros(6, 1);
        M.prior{1}.std = ones(6, 1);
        M.prior{1}.columns = (1:6)';
        M.prior{1} = u_prior_linearsetup(M.prior{1});
    
        M.prior{2}.variance = eye(2);
        M.prior{2}.df = 5;
        M.prior{2}.columns = (7:9)';
        M.prior{2} = u_prior_wishartsetup(M.prior{2});
    end
    
    C.tfirst = 1;
    C.tlast = size(M.data, 1);
    M.A = A;
    M.B = B;
    M.H = H;
    
elseif strcmp(stage, 'finish')
    disp('A matrix');  disp(M.A)
    disp('B matrix');  disp(M.B)
    disp('H matrix');  disp(M.H)

    Amean = u_allocate([M.n, M.n]);
    Astd  = u_allocate([M.n, M.n]);
    for i = 1:M.n
        for j = 1:M.n
            if M.Amap(i,j) == 0
                Amean(i,j) = 0;
                Astd(i,j) = 0;
            else
                Amean(i,j) = u_mean(Cpar.theta(:,M.Amap(i,j)), 1, E.pus>1);
                Astd(i,j) = u_std(Cpar.theta(:,M.Amap(i,j)), 1, E.pus>1);
            end
        end
    end
    disp('A posterior mean');  disp(Amean)
    disp('A posteror std');  disp(Astd)
    disp('t stats');  disp((Amean-M.A)./Astd)

    Bmean = u_allocate([M.n, M.k]);
    Bstd  = u_allocate([M.n, M.k]);
    for i = 1:M.n
        for j = 1:M.k
            if M.Bmap(i,j) == 0
                Bmean(i,j) = 0;
                Bstd(i,j) = 0;
            else
                Bmean(i,j) = u_mean(Cpar.theta(:,M.Bmap(i,j)), 1, E.pus>1);
                Bstd(i,j) = u_std(Cpar.theta(:,M.Bmap(i,j)), 1, E.pus>1);
            end
        end
    end
    disp('B posterior mean');  disp(Bmean)
    disp('B posteror std');  disp(Bstd)
    disp('t stats');  disp((Bmean-M.B)./Bstd)
    
    Hmean = u_allocate([M.n, M.n]);
    Hstd  = u_allocate([M.n, M.n]);
    for i = 1:M.n
        for j = i:M.n
            xx = Cpar.theta(:,M.Hmap(i,j));
            if i == j
                xx = exp(xx);
            end
            Hmean(i,j) = u_mean(xx, 1, E.pus>1);
            Hstd(i,j) = u_std(xx, 1, E.pus>1);
        end
    end
    disp('H posterior mean');  disp(Hmean)
    disp('H posteror std');  disp(Hstd)
    disp('t stats');  disp((Hmean - M.H)./Hstd)
            
                
end
    
end
