function p_monitor(stage)
%  Set up the information structure for this project. 
%  Set up any additional infrastructure specific to the project,
%  creating a P structure to do so if desired.
%
%  Intput:
%  stage        Current stage of the SABL algorithm

global C E M
    
if strcmp(stage, 'open')
    E.gpu = true;
    % E.pus = 2;
    
elseif strcmp(stage, 'startrun')
    
    %  Part 1: Set up the data
    load garch_data
    dy = diff(log(g_data));
    T = length(dy);
    M.data = dy;
    M.y_pointer = 1;
    
    %  Part 2: Change SABL default parametera
    
    %  Part 3: Map algorithm parameters (theta) to model parameters
    %  No map, so default map will be used
    M.K = 2;
    M.I = 3;
    
    %  Part 4: Set up the prior using the default structure
    M.muYprior.mean = 0;
    M.muYprior.std = 1;
    M.sigmaYprior.mean = log(0.01);
    M.sigmaYprior.std = 1;
    M.alphaprior.mean = atanh(0.95);
    M.alphaprior.std = 1;
    M.betaprior.mean = log(0.1);
    M.betaprior.std = 1;
    M.gammaprior.mean = 0;
    M.gammaprior.std = 0.2;
    M.muprior.mean = 0;
    M.muprior.std = 0.2;
    M.pprior.mean = 0;
    M.pprior.std = 0.2;
    M.sigmaprior.mean = 0;
    M.sigmaprior.std = 0.2;
    C.detail_level = 7;
    C.nlcuda = false;
end
   
end
