function p_monitor(stage)
%  Set up the information structure for this project. Default fields in the
%  M structure are for illustration only, so they will be re-set, in
%  general. Set up any additional infrastructure specific to the project,
%  creating a P structure to do so if desired.
%
%  Intput:
%  stage        Current stage of the SABL algorithm

global C Cpar E M P
    
if strcmp(stage, 'open')
    % E.gpu = true;
    % E.pus = 2;
    
elseif strcmp(stage, 'startrun')

%  Part 1: Set up the data
     load fakedat; 
     logGDP = log(data(:,P.country));

%     load OECD_GDPdat;
%     [~, ii, ~] = intersect(years, P.years);
%     logGDP = log(data(P.country,ii))';
    
    T = size(logGDP, 1);
    M.data = [ones(T-3, 1), zeros(T-3,4)];
    for j = 0:3
        M.data(:,j+2) = logGDP(4-j:T-j);
    end
    M.x_pointer = [1; 3; 4; 5];
    M.y_pointer = 2;
    M.z_pointer = 1;
    
%  Part 2: Make any changes in the SABL default parameters
%     [Nothing here]

%  Part 3: Set up the parameter map
    M.betmap = [1; 100; 100; 100];
    M.gammap = 5;

%  Part 4: Set up the prior distribution
    M.prior{1}.distribution = 'normal';
    %  Order is beta_1, log(alpha_s), log(alpha_c), log(p), log(var(sigma))
    M.prior{1}.mean = [0; 0; log(0.05); log(4.5); log(0.025^2)];
    M.prior{1}.std = [0.1; 0.1; log(2); log(3); 1];
    M.prior{1}.columns = (1:5)';
    M.prior{1} = u_prior_linearsetup(M.prior{1});

elseif strcmp(stage, 'close')
    Cpar.theta1 = u_mixmap(Cpar.theta);    
end

end






