clear all;  close all;
load run1results
fs = 14;
ngrid = 101;

load OECD_GDPdat
func = cell(4,1);
func{1} = 'Secular amplitude';
func{2} = 'Cyclical amplitude';
func{3} = 'Periodicity (years)';
func{4} = 'Shock standard deviation';
argden = [linspace(0.95, 1.05, 101); linspace(0, 0.3, ngrid);
    linspace(0, 20, 101); linspace(0.01, 0.03, ngrid)];

for j = 1:length(usecountries)
    figure(j)
    country = char(countries{usecountries(j)});
    for i = 1:4
        subplot(2,2,i)
        g = squeeze(exp(run1particles(j,:,i)));
        if i == 4
            g = sqrt(g);
        end
        den = ksdensity(g, argden(i,:));
        plot(argden(i,:), den, 'k-')
        header = sprintf('%s  %s', country, func{i});
        title(header, 'FontSize', fs)
        xlabel(sprintf('%s', func{i}), 'FontSize', fs)
        ylabel('Posterior p.d.f.', 'FontSize', fs)
        axis([argden(i,1), argden(i,ngrid), ylim])
        set(gca, 'FontSize', fs)
    end
    pause
end
        
