clear all;  close all;
global C Cpar P
load OECD_GDPdat;

% run1: 1970 forward for the 27 countries with data
usecountries = find(~isnan(data(:,6)));
P.years = 1970:2014;
ncountries = length(usecountries);

run1particles = zeros(ncountries, 2^14, 4);
wallclock = zeros(ncountries, 1);
cpuclock  = zeros(ncountries, 1);
logml = zeros(ncountries, 1);
% for j = 1:2
for j = 1:ncountries
    fprintf('\nStarting country %d, %s\n', j, char(countries{j}))
    pause(2)
    P.country = usecountries(j);
    SABL('normal')
    run1particles(j,:,:) = Cpar.theta(:,[2,3,4,5]);
    fprintf('\nEnding country %d, %s\n', j, char(countries{j}))
    wallclock(j) = C.walltime;
    cpuclock(j) = C.cptime;
    logml(j) = C.logml1;
end

sampleyears = P.years;
save run1results run1particles wallclock cpuclock logml ...
    usecountries sampleyears