function algorithm

%  The occurence of "Stage: [name]" indicates that control passes 
%  -> c_monitor -> m_monitor -> p_monitor -> m_monitor -> c_monitor -->
%  If "Stage" appears following the description of an operation then
%  c_monitor requires input from p_monitor ('startrun') or m_monitor
%  (all other such occurrences). The function p_monitor should modify
%  E control fields only in stage 'open' and should set or modify C and M
%  control fields only in stage 'startrun'. The function p_monitor can
%  harvest information from SABL global structures in any stage/ 
%
%  Outline of the SABL algorithm:
%
%  Retrieve particles to be updated (if E.simulation_get specified)
%  Set SABL environment                                
%  Stage: 'open'
%  for pass = first, [second if C.twopass = true]
%    Define the problem, including priors and data     Stage: 'startrun'
%    Copy global structures from one to multiple workers if E.pus >  1
%    Draw particles from prior if not updating         Stage: 'initialize'
%    while SABL cycles = 1, 2, 3, ...
%      Stage: 'startcycle'
%      Initialize C (Correction) phase weight function
%      Stage: 'startCphase'
%      while C phase steps incomplete
%        Update the weight function                    Stage: 'whileCphase'
%      end
%      Stage: 'endCphase'
%      Stage: 'startSphase'
%      Execute S (Selection) phase
%      Stage: 'endSphase'
%      Stage: 'startMphase'
%      while M (Mutation) phase steps incomplete
%        Execute the next step                         Stage: 'whileMphase'
%      end
%      Stage: 'endMphase'
%    end
%    Stage: 'finish'
%    Stage: 'endrun'
%    Copy global structures from multiple workers to one if E.pus > 1
%  end
%  Stage: 'close'
%  Save particles for future updating (if E.simulation_record specified)
%
%  Subsidiary topics:
%     help Cphase, Sphase, Mphase
%     help environment, parametermaps, pass, updating
