%  This code tests the various combinations of prior specification that
%  are possible in u_prior_linear_setup.  Hence it is not necessary to
%  retest these combinations in test1_linear.

clear all;  close all;
pmean = 0;
pstd = 1;
% R = diag([2.1, 3]);
% R = [2.1 -1; 0.5 3];
R = 1;
format1 = 'normal';
% df = 6;
% constraints.a = 0;
% constraints.b = inf;
% constraints.D = [1, 0];
mixed.mvector = [0;  1];
mixed.pvector = [0.3; 0.4];

n = length(pmean);
hpmom1 = [pmean, pstd];
hpmom2 = R;
disp('linear combinations')
prior = ...
    u_prior_linearsetup(format1, 'linear combinations', hpmom1, hpmom2, ...
    [], [], mixed)
disp('prior.mean');  disp(prior.mean)
disp('prior.var');  disp(prior.var)
disp('prior.prec');  disp(prior.prec)
disp('prior.varchol');  disp(prior.varchol)
disp('prior.precchol');  disp(prior.precchol)
% disp('prior.constraints.a');  disp(prior.constraints.a)
% disp('prior.constraints.b');  disp(prior.constraints.b)
% disp('prior.constraints.D');  disp(prior.constraints.D)
% disp('prior.constraints.Dinv');  disp(prior.constraints.Dinv)
% disp('prior.constraints.logdetD');  disp(prior.constraints.logdetD)
disp('prior.mixed');  disp(prior.mixed)
disp('prior.mixed.mvector');  disp(prior.mixed.mvector)
disp('prior.mixed.pvector');  disp(prior.mixed.pvector)


Rinv = R\eye(prior.n);
pmean = Rinv*hpmom1(:,1);
pvar = (Rinv*diag(hpmom1(:,2).^2)*Rinv');
% hpmom1 = pmean;
% hpmom2 = sqrt(diag(pvar));
% disp('mean-std')
% prior = u_prior_linearsetup('normal', 'mean-std', hpmom1, hpmom2)
% disp('prior.mean');  disp(prior.mean)
% disp('prior.var');  disp(prior.var)
% disp('prior.prec');  disp(prior.prec)
% disp('prior.varchol');  disp(prior.varchol)
% disp('prior.precchol');  disp(prior.precchol)
% pause

% hpmom1 = pmean;
% hpmom2 = pvar;
% disp('mean-variance')
% prior = u_prior_linearsetup(format1, 'mean-variance', hpmom1, hpmom2, ...
%     df, constraints)
% disp('prior.mean');  disp(prior.mean)
% disp('prior.var');  disp(prior.var)
% disp('prior.prec');  disp(prior.prec)
% disp('prior.varchol');  disp(prior.varchol)
% disp('prior.precchol');  disp(prior.precchol)
% disp('prior.constraints.a');  disp(prior.constraints.a)
% disp('prior.constraints.b');  disp(prior.constraints.b)
% disp('prior.constraints.D');  disp(prior.constraints.D)
% disp('prior.constraints.Dinv');  disp(prior.constraints.Dinv)
% disp('prior.constraints.logdetD');  disp(prior.constraints.logdetD)
% pause

% hpmom2 = pvar\eye(n);
% disp('mean-precision')
% prior = u_prior_linearsetup(format1, 'mean-precision', hpmom1, hpmom2, ...
%     df, constraints)
% disp('prior.mean');  disp(prior.mean)
% disp('prior.var');  disp(prior.var)
% disp('prior.prec');  disp(prior.prec)
% disp('prior.varchol');  disp(prior.varchol)
% disp('prior.precchol');  disp(prior.precchol)
% disp('prior.constraints.a');  disp(prior.constraints.a)
% disp('prior.constraints.b');  disp(prior.constraints.b)
% disp('prior.constraints.D');  disp(prior.constraints.D)
% disp('prior.constraints.Dinv');  disp(prior.constraints.Dinv)
% disp('prior.constraints.logdetD');  disp(prior.constraints.logdetD)
disp('Variance recovered from Choleski')
disp(prior.varchol'*prior.varchol)
disp('Precision recovered from Choleski')
disp(prior.precchol'*prior.precchol)
pause

