function [theta, prior] = test1_linear(JN, format1, format2, hpmom1, hpmom2, ...
    df, constraints, mixed)
time = zeros(4,1);
time0 = tic;
if nargin == 2
    prior = u_prior_linearsetup(format1);
elseif nargin == 5
    prior = u_prior_linearsetup(format1, format2, hpmom1, hpmom2);
elseif nargin == 6
    prior = u_prior_linearsetup(format1, format2, hpmom1, hpmom2, df);
elseif nargin == 7
    prior = u_prior_linearsetup(format1, format2, hpmom1, hpmom2, ...
        df, constraints);
else
    prior = u_prior_linearsetup(format1, format2, hpmom1, hpmom2, ...
        df, constraints, mixed);
end
time(1) = toc(time0);
time1 = tic;
[theta, prior] = u_prior_linearsim(JN, prior);
time(2) = toc(time1);
time2 = tic;
% if prior.mix
%     x = u_cont_to_mixed(theta, prior.mixed.mvector, prior.mixed.rvector, ...
%         prior.mixed.svector);
%     size(theta)
%     [theta(1:10,:), x(1:10)]
%     sum(x == prior.mixed.mvector)/JN
%     y = x(x ~= prior.mixed.mvector);
%     length(y)
%     y(1:10)
%     figure(1)
%     subplot(3,1,1);  hist(theta)
%     subplot(3,1,3);  hist(y)
%     subplot(3,1,2);  hist(x)
% end
logp = u_prior_linear(theta, prior);
time(3) = toc(time2);
time3 = tic;
[~, ~] = u_pdfcheck(theta, exp(logp), true);
time(4) = toc(time3);
fprintf('Setup %8.4f  Sim %8.4f  pdf %8.4f  Test %8.4f\n', time)

end
    