clear all;  close all;

t1 = 0.150;  %  ~= phi(1.4)
t2 = 2.18;
t3 = 0.725;
t4 = 0.45;
mu = 2;
sig = 1.5;

nrep = 10000;
a = [t4-0.05; t4+0.05;  -1;  -2; 0.5; 0.6; 1.0];
b = [    inf;     inf; 0.8; 0.8;   1; 2.2; 3.0];
b(8:14) = -a(1:7);
a(8:14) = -b(1:7);
a = mu + sig*a;
b = mu + sig*b;
xfull = normrnd(mu, sig, 20*nrep, 1);
x = zeros(nrep, 1);
for j = 1:14
    for i = 1:nrep
        x(i) = u_normtruncrnd(mu, sig, a(j), b(j));
    end
    x2 = x.^2;
    y = xfull(xfull>=a(j) & xfull<=b(j));
    y2 = y.^2;
    ny = length(y2);
    t = (mean(x) - mean(y))/sqrt(var(x)/nrep + var(y)/ny);
    t2 = (mean(x2) - mean(y2))/sqrt(var(x2)/nrep + var(y2)/ny);
    fprintf('%d %10.4f %10.4f %10.4f %10.4f %10.4f %10.4f\n', ...
        j, mean(x), mean(y), mean(x2), mean(y2), t, t2)
end