clear all;  close all;

ntest = 1;

if ntest == 1
    mu = 0;
    varchol = 1;
    D = 1; 
    a = 1;
    b = inf';
    nsimouter = 10;
    nsiminner = 1000;
    df = 6;
    
elseif ntest == 2
    mu = [0.2; 0.8];
    varchol = [1 2; 0 1.5];
    D = [1 -1; 0 1];
    a = [-1; 0.1];
    b = [1.5; inf];
    nsimouter = 10;
    nsiminner = 1000;
    df = inf;
    
elseif ntest == 3
    mu = [0.2; 0.8; 0];
    varchol = [1 2 .5; 0 1 -.3; 0 0 1.2];
    D = [1 -1 1.5; 0 0.5 0.8; 0 0 0.95];
    a = [-1; 0.1; -1];
    b = [1.5; inf; 2];
    nsimouter = 10;
    nsiminner = 1000;
    df = 8;
end

n = length(mu);
time1 = tic;
[logprob, logprobnse, xsim] = ...
    u_GHKprob(mu, varchol, D, a, b, nsimouter, nsiminner, df);
% [logprob, logprobnse] = ...
%     u_GHKprob(mu, varchol, D, a, b, nsimouter, nsiminner, df);

fprintf('GHKprob log P(constraints satisfied): %12.5e (%11.5e)\n', ...
    logprob, logprobnse)
prob = exp(logprob);
probnse = logprobnse*prob;
fprintf('    GHKprob P(constraints satisfied): %12.5e (%11.5e)\n', ...
    prob, probnse)
fprintf('                                Time: %9.4f seconds\n', ...
    toc(time1))
if length(mu) == 1
    hist(xsim)
else
    plot(xsim(:,1), xsim(:,2), 'r.')
end

nrep = round(nsimouter*nsiminner/prob);
sigma = varchol'*varchol;
time2 = tic;
x = mvnrnd(mu', sigma, nrep)';  % n x nrep
if ~isinf(df)
    w = sqrt(chi2rnd(df, 1, nrep)/df);
    x = x./repmat(w, n, 1);
end
z = D*x;
nok = sum(all(repmat(a, 1, nrep) <= z & z <= repmat(b, 1, nrep)));
prob1= nok/nrep;
probnse1 = sqrt(prob1*(1-prob1)/nrep);
fprintf('Brute force P(constraints satisfied): %12.5e (%11.5e)\n', ...
    prob1, probnse1)
fprintf('                                Time: %9.4f seconds\n', ...
    toc(time2))
fprintf('                      Test statistic: %12.3f\n', ...
    (prob-prob1)/sqrt(probnse^2 + probnse1^2))