clear all;  close all
global C
addpath ..
C.J = 8;
C.N = 512;
JN = C.J*C.N;

ntest = 4;
prior.df = 20;

if ntest == 1
    prior.mean = 2;
    prior.std = 0.8;
%     prior.mean = zeros(2, 1);
%     prior.variance = eye(2);
%     prior.precision = eye(2);
%     prior.std = [0.8; 0.2];
%     prior.R = eye(2);
%     prior.r = [0.5; -0.5];

elseif ntest == 2
    prior.mean = [2; 1];
    prior.variance = [1, .5; .5, 1.8];
end

if ntest == 3
    prior.mean = [0.5; -0.5; 0];
    prior.variance = [0.9, 0.5, -0.2; 0.5, 1.1, 0.4; -0.2, 0.4, 1];
    prior.constraints.a = -ones(2,1);
    prior.constraints.b = ones(2,1);
    prior.constraints.D = [1 1 0; 1 -1 0];
end

if ntest == 4
    prior.mean = 0.5;
    prior.variance = 1.2;
    prior.mixed.mass = [0; 1];
    prior.mixed.prob = [0.25; 0.25];
end

if ntest == 5
    prior.mean = 0;
    prior.variance = 1;
    prior.constraints.a = 0;
    prior.constraints.b = inf;
    prior.constraints.D = 1;
    prior.mixed.mass = 0.5;
    prior.mixed.prob = 0.5;
end

prior = u_prior_linearsetup(prior);
[theta, prior] = u_prior_linearsim(JN, prior);
logp = u_prior_linear(theta, prior);

[tstatout,pstatout] = u_pdfcheck(theta, exp(logp), true);

if prior.mix
    theta1 = u_cont_to_mixed(theta, prior.mixed.mass, ...
        prior.mixed.r, prior.mixed.s);
end