clear all;  close all;
% BP: Created and tested on 2014-08-27
global E

E.gpu = false;
E.pus = 1;

nsim     = 10000;
n_sample = 1000;
SigS = [1 0.2; 0.2 1];
p    = size(SigS, 1);

fprintf('\nTruncated Normal\n')
spec = cell(8,1);
spec{1} = ones(p, 1);
spec{2} = SigS;
spec{3} = [];
spec{4} = [];
spec{5} = inf;
spec{6} = [1 0.2; 0.2 1];
spec{7} = [1.2 1.95]';
spec{8} = [1.25 2]';

[pmean, pvar, pvarchol, prec, precchol, pnu, pD, pDinv, plogdetD, pa, pb] = ...
    u_prior_linearsetup('mean-variance', spec); 
  
[y, logW] = u_prior_linearsim(nsim, pmean, pvarchol, pnu, pD, pDinv, pa, pb);
py = u_prior_linear(y, pmean, precchol, pnu, logW, pD, pa, pb); 
py = exp(py);
[tstatout11, pstatout12] = u_pdfcheck(y(1:n_sample, :), py(1:n_sample), 1); %#ok<*ASGLU>

fprintf('\nTruncated Student t\n')
spec = cell(8,1);
spec{1} = ones(p, 1);
spec{2} = SigS;
spec{3} = [];
spec{4} = [];
spec{5} = 5;
spec{6} = [1 0.2; 0.2 1];
spec{7} = [1.2 1.95]';
spec{8} = [1.25 2]';

[pmean, pvar, pvarchol, prec, precchol, pnu, pD, pDinv, plogdetD, pa, pb] = ...
    u_prior_linearsetup('mean-variance', spec);  

[y, logW] = u_prior_linearsim(nsim, pmean, pvarchol, pnu, pD, pDinv, pa, pb);
py = u_prior_linear(y, pmean, precchol, pnu, logW, pD, pa, pb); 
py = exp(py);
[tstatout21, pstatout22] = u_pdfcheck(y(1:n_sample, :), py(1:n_sample), 1); %#ok<*NASGU>

fprintf('\nUntruncated Normal\n')
spec = cell(8,1);
spec{1} = ones(p, 1);
spec{2} = SigS;
spec{3} = [];
spec{4} = [];
spec{5} = inf;

[pmean, pvar, pvarchol, prec, precchol, pnu, pD, pDinv, plogdetD, pa, pb] = ...
    u_prior_linearsetup('mean-variance', spec);  
  
[y, ~] = u_prior_linearsim(nsim, pmean, pvarchol, pnu);
py = u_prior_linear(y, pmean, precchol, pnu); 
py = exp(py);
[tstatout11, pstatout12] = u_pdfcheck(y(1:n_sample, :), py(1:n_sample), 1);

fprintf('\nUntruncated Student t\n')
spec = cell(8,1);
spec{1} = ones(p, 1);
spec{2} = SigS;
spec{3} = [];
spec{4} = [];
spec{5} = 5;

[pmean, pvar, pvarchol, prec, precchol, pnu, pD, pDinv, plogdetD, pa, pb] = ...
    u_prior_linearsetup('mean-variance', spec);  

[y, ~] = u_prior_linearsim(nsim, pmean, pvarchol, pnu);
py = u_prior_linear(y, pmean, precchol, pnu); 
py = exp(py);
[tstatout21, pstatout22] = u_pdfcheck(y(1:n_sample, :), py(1:n_sample), 1);


