clear all;  close all;
% mvector = 0;
% pvector = 0.5;
mvector = [0; 1];
pvector = [0.3; 0.2];
pdfvector = (1-sum(pvector))*normpdf(mvector, 0, 1);
[rvector, svector] = u_rscreate(mvector, pvector, pdfvector);
n = length(mvector);
fprintf('   mvector   pvector   rvector   svector\n')
for j = 1:n
    fprintf('%9.4f %9.4f %9.4f %9.4f\n', ...
        mvector(j), pvector(j), rvector(j), svector(j))
end

JN = 50;
x = randn(JN,1);

[x, xstar] = u_mixedrnd(x, mvector, pvector, rvector, svector);
x1 = u_cont_to_mixed(xstar, mvector, rvector, svector);

pdf = (1 - sum(pvector))*normpdf(x1);
pdf = u_pdfstar(xstar, pdf, rvector, svector, pvector);
fprintf('Random variables generated from distribution\n')
fprintf('   Original  Continuous     Re-map   Cont. pdf   Test re-map\n')
for i = 1:JN
    fprintf('%11.5f %11.5f %11.5f %11.5f %14.5f\n', ...
        x(i), xstar(i), x1(i), pdf(i), x(i)-x1(i))
end

argx = linspace(min(x), max(x), 201);
argxstar = linspace(min(xstar), max(xstar), 201);
plot(argx, (1-sum(pvector))*normpdf(argx), 'r-');  hold on;
for j = 1:n
    plot([mvector(j), mvector(j)], [0, pvector(j)], 'b:')
    plot(mvector(j), pvector(j), 'bo')
end
title('Mixed continuous-discreted pdf')
figure(2)
x1 = u_cont_to_mixed(argxstar, mvector, rvector, svector);
pdf = (1 - sum(pvector))*normpdf(x1);
pdf = u_pdfstar(argxstar, pdf, rvector, svector, pvector);
plot(argxstar, pdf, 'r-')
title('pdf of continuous representation')
