clear all;  close all;
global C
C.JNwork = 1e3;
C.parameters = 1;
ntest = 2;

if ntest == 1
    prior.endpoints = [0, 1; 0, 2];
    prior = u_prior_uniformsetup(prior);
    theta = u_prior_uniformsim(C.JNwork, prior);
    logp = u_prior_uniform(theta, prior);
    plot(theta(:,1), theta(:,2), 'r.')
    fprintf('%d unique values of logp\n', length(unique(logp)))
    fprintf('Value of log p:%9.4f %9.4f\n', mean(logp), exp(mean(logp)))
    
elseif ntest == 2
    prior.endpoints = [0, 10];
    prior.mixed.mass = [3; 7];
    prior.mixed.prob = [0.3; 0.3];
    prior = u_prior_uniformsetup(prior);
    theta = u_prior_uniformsim(C.JNwork, prior);
    logp = u_prior_uniform(theta, prior);
    theta1 = u_cont_to_mixed(theta, prior.mixed.mass, ...
        prior.mixed.r, prior.mixed.s);
    hist(theta1)
end