function a_out = u_gcat(a_in, DIM, labtarget)
% Aggregate data from different workers to one worker or client. This
% function works both inside and outside the SPMD block.
%
%  Inputs:
%  a_in        Data to be aggregated: either a regular array/matrix, or
%              else a Composite array generated by MATLAB parallel 
%              computing toolbox.      
%  DIM         Dimension to aggregate along
%  labtarget   Which worker to place the a_out
%
%  Output:
%  a_out       Aggregated data, could be a regular array/matrix on the
%              client (outside the SPMD block) or a distributed array
%              inside the SPMD block with all data only on labtarget.

if 3 > nargin
    labtarget = 1;
end

if 2 > nargin
    DIM = 1;
end

if 1 < numlabs
    a_out = gcat(a_in, DIM, labtarget);
else
    if isa(a_in,'Composite')
        a_out = [];        
        for i = 1:length(a_in)
            if 1==DIM
                a_out = [a_out; a_in{i}];
            else
                a_out = [a_out, a_in{i}];
            end            
        end
    else
        a_out = a_in;
    end
end